<?php
/**
* Copyright © Magento, Inc. All rights reserved.
* See COPYING.txt for license details.
*/
namespace FiloBlu\Newsletter\Block\Widget;

use FiloBlu\Newsletter\Helper\Data;

/**
* @SuppressWarnings(PHPMD.CouplingBetweenObjects)
*/
class Country extends \Magento\Directory\Block\Data
{

    private $serializer;

    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Magento\Directory\Helper\Data $directoryHelper,
        \Magento\Framework\Json\EncoderInterface $jsonEncoder,
        \Magento\Framework\App\Cache\Type\Config $configCacheType,
        \Magento\Directory\Model\ResourceModel\Region\CollectionFactory $regionCollectionFactory,
        \Magento\Directory\Model\ResourceModel\Country\CollectionFactory $countryCollectionFactory,
        Data $helperData,
        array $data = []
    ){
        parent::__construct($context, $directoryHelper, $jsonEncoder, $configCacheType, $regionCollectionFactory, $countryCollectionFactory, $data);
        $this->_helper = $helperData;
    }

    public function getCountryHtmlSelect($defValue = null, $name = 'country_id', $id = 'country', $title = 'Country')
    {
        \Magento\Framework\Profiler::start('TEST: ' . __METHOD__, ['group' => 'TEST', 'method' => __METHOD__]);
        /*if ($defValue === null) {
            $defValue = $this->getCountryId();
        }*/
        $defValue = null;
        $cacheKey = 'NEWSLETTER_DIRECTORY_COUNTRY_SELECT_STORE_' . $this->_storeManager->getStore()->getCode();
        $cache = $this->_configCacheType->load($cacheKey);
        if ($cache) {
            $options = $this->getSerializer()->unserialize($cache);
        } else {
            $options = $this->getCountryCollection()
            ->setForegroundCountries($this->getTopDestinations())
            ->toOptionArray();

            $this->_configCacheType->save($this->getSerializer()->serialize($options), $cacheKey);
        }

        $required = $this->_helper->getConfig("popup/country_required") ? "true" : "false";

        $html = $this->getLayout()->createBlock(
            \Magento\Framework\View\Element\Html\Select::class
            )->setName(
                $name
            )->setId(
                $id
            )->setTitle(
                __($title)
            )->setValue(
                $defValue
            )->setOptions(
                $options
            )->setExtraParams(
                "data-validate=\"{'validate-select': ".$required."}\""
            )->getHtml();

            \Magento\Framework\Profiler::stop('TEST: ' . __METHOD__);
            return $html;
    }

    /**
     * Get serializer
     *
     * @return \Magento\Framework\Serialize\SerializerInterface
     * @deprecated 100.2.0
     */
    private function getSerializer()
    {
        if ($this->serializer === null) {
            $this->serializer = \Magento\Framework\App\ObjectManager::getInstance()
                ->get(\FiloBlu\Newsletter\Serialize\Serializer::class);
        }
        return $this->serializer;
    }

}
